---
layout: lesson
root: ../..
title: Using Databases and SQL
level: novice
---
Almost everyone has used spreadsheets,
and almost everyone has eventually run up against their limitations.
The more complicated a data set is,
the harder it is to filter data,
express relationships between different rows and columns,
or handle missing values.

Databases pick up where spreadsheets leave off.
While they are not as simple to use if all we want is the sum of a dozen numbers,
they can do a lot of things that spreadsheets can't,
on much larger data sets,
faster.
And even if we never need to create a database ourselves,
knowing how they work will help us understand why so many of the systems we use
behave the way we do,
and why they insist on structuring data in certain ways.

Topics
------
1.  [Selecting Data](01-select.html)
2.  [Sorting and Removing Duplicates](02-sort-dup.html)
3.  [Filtering](03-filter.html)
4.  [Calculating New Values](04-calc.html)
5.  [Missing Data](05-null.html)
6.  [Aggregation](06-agg.html)
7.  [Combining Data](07-join.html)
8.  [Creating and Modifying Data](08-create.html)
9.  [Programming with Databases](09-prog.html)

See Also
--------
*   [Instructor's Guide](guide.html)
*   [Reference](reference.html)

Resources
---------
*   `gen-survey-database.sql`: re-generate survey database used in examples.
*   `sqlitemagic.py`: IPython Notebook plugin to support SQLite interaction.
